#!/usr/bin/python
# coding: UTF-8

# #############################################################################
# ieServer.Net: 無料ダイナミックDNS(DDNS)サービス用 IPアドレス更新スクリプト
# バージョン : 0.1
# 作成日時: 2014/01/21
# 更新日時: 2014/01/22
# 作者 : hiro
# #############################################################################

import commands
import os
import codecs
from datetime import datetime


#以下の部分をご自身の環境に合わせて、調整してください


MYPATH = "/usr/local/bin/ieserver/"     #このpythonスクリプトの配置場所
SUBDOMAIN_NAME = "example"              #サブドメイン名
DOMAIN_NAME = "dip.jp"                  #ドメイン名
PWD = "xxxxxxx"                         #パスワード

#強制アップデート時間帯
#このスクリプトの実行間隔を１時間以下（0〜59分）に設定している場合は変更する必要はありません。
#１日に一度ぐらいは更新処理をかけておいたほうが良いので、ご自身がCronで実行する
#時刻をセットしておいてください。（時間は二桁で記述してください。 2時なら 02 とする。）
FORCE_UPDATE_HOUR = "02"


#設定終わり（これ以下は変更する必要はありません）


#Crontab 設定方法
# sudo crontab -e として、以下のように記述（１０分間隔で実行）
# 5,15,25,35,45,55 * * * * /usr/local/bin/ieserver/ieserver-update.py




REMOTE_ADDR_CHK = "http://ieserver.net/ipcheck.shtml"
DDNS_UPDATE = "http://ieserver.net/cgi-bin/dip.cgi"



currIp = commands.getoutput("wget -q -O - " + REMOTE_ADDR_CHK)

line = "none"

if os.path.exists(MYPATH + "saveip.txt") == True:
	f = open(MYPATH + "saveip.txt","r")

	for line in f:
		dummy = line

	f.close
	


hour = datetime.now().strftime('%H') 

if (currIp != line) or hour == FORCE_UPDATE_HOUR:

	cmd = "wget -q -O - '"
	cmd += DDNS_UPDATE + "?username=" + SUBDOMAIN_NAME
	cmd += "&domain=" + DOMAIN_NAME
	cmd += "&password=" + PWD
	cmd += "&updatehost=1'"

	ret = commands.getoutput(cmd)

	#f2 = codecs.open(MYPATH + "return.html","w","eucjp")
	#f2.write(ret.decode("eucjp"))
	#f2.close


	#222.222.222.222 に設定されています
	if (currIp + u" に設定されています") in ret.decode("eucjp"):
		f2 = open(MYPATH + "saveip.txt","w")
		f2.write(currIp)
		f2.close

		f2 = open(MYPATH + "update.log","a")
		line =  datetime.now().strftime('%Y/%m/%d %H:%M:%S') 
		line += "\tIP Address を更新しました。[" + currIp + "]\n" 
		f2.write(line)
		f2.close

	else:
		f2 = open(MYPATH + "update.log","a")
		line =  datetime.now().strftime('%Y/%m/%d %H:%M:%S') 
		line += "\tIP Address の更新に失敗しました。\n"
		f2.write(line)
		f2.close


#else:
#	f2 = open(MYPATH + "not-update.log","a")
#	line =  datetime.now().strftime('%Y/%m/%d %H:%M:%S') 
#	line += "\tIP Address 更新を保留しました。[" + currIp + "]\n" 
#	f2.write(line)
#	f2.close




